package org.switchyard.quickstarts.rest.binding;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.StringReader;

import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

//import org.switchyard.annotations.Transformer;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public final class LoggingServiceTransformer {

	@org.switchyard.annotations.Transformer(to = "{urn:com.example.switchyard:ADR-ProtoType:1.0}addLogResponse")
	public Element transformStringToAddLogResponse(String from) {
		System.out.println("*** transformStringToAddLogResponse: "+from);
		StringBuilder builder = new StringBuilder();
		builder.append("<tns:addLogResponse xmlns:tns=\"urn:com.example.switchyard:ADR-ProtoType:1.0\">");
		builder.append("<tns:return>");
		builder.append(from);
		builder.append("</tns:return>");
		builder.append("</tns:addLogResponse>");
		return toElement(builder.toString());
	}
	
	@org.switchyard.annotations.Transformer(from = "{urn:com.example.switchyard:ADR-ProtoType:1.0}addLog")
	public String transformAddLogToString(Element from) {
		System.out.println("*** transformAddLogToString");
		return new String(getElementValue(from, "log"));
	}
	
	private String getElementValue(Element parent, String elementName) {
		String value = "getElementValue node not found";

		if (parent != null) {
		
			NodeList nodes = parent.getElementsByTagName(elementName);
	
			if (nodes.getLength() > 0) {
				value = nodes.item(0).getChildNodes().item(0).getNodeValue();
			} else {
				NodeList nodeList = parent.getChildNodes();
				if (nodeList != null) {
					if (nodeList.getLength() > 1)
						System.out.println("WARNING: Element had more than 1 node ["+nodeList.getLength()+"]");
					for (int i= 0; i < nodeList.getLength(); i++) {
						Node node = nodeList.item(i);
						value = node.getNodeValue();
					}
				}
			}
		}

		return value;
	}

	private Element toElement(String string) {
		DOMResult dom = new DOMResult();
		System.out.println("*** transformAddLogToString.toElement(): "+string);
		try {
			TransformerFactory.newInstance().newTransformer()
					.transform(new StreamSource(new StringReader(string)), dom);
		} catch (Exception e) {
			e.printStackTrace();
		}
		System.out.println("*** transformAddLogToString.getNodeName(): "+((Document) dom.getNode()).getDocumentElement().getNodeName());
		System.out.println("*** transformAddLogToString.getFirstChild(): "+((Document) dom.getNode()).getDocumentElement().getFirstChild().getNodeName());
		System.out.println("*** transformAddLogToString.getTextContent(): "+((Document) dom.getNode()).getDocumentElement().getFirstChild().getTextContent());
		return ((Document) dom.getNode()).getDocumentElement();
	}
	
}
